class veta{
    constructor(rodic,priklad){
        this.rodic = document.getElementById(rodic); 
        this.obt = priklad;
        this.drag = "drag_"+priklad;
        this.drop = "drop_"+priklad;
        this.pocetDoplnovani = 6;
        this.sl_all = ["byk","bylina","kobyla","nabytek","pribytek","hlemyzd","mys","syr","sysel","kopyto","netopyr","pytel","vydra","vyhen","vyr","delfin","mleko","obiloviny","ohniste","papir","ryba"];
                  //     1       2        3         4          5          6      7    8      9        10       11       12      13     14      15    16     17        18         19        20      21      
        this.vety1 = [
                        ['<span id="sp_0"></span> se lidově říká šnek.',6],
                        ['Nejrozšířenějším hlodavcem na světě je <span id="sp_0"></span> domácí.',7],
                        ['Hlavním protagonistou večerníčku Vydrýsek je malá <span id="sp_0"></span> říční.',13],
                        ['Samec tura domácího se nazývá <span id="sp_0"></span>.',1],
                        ['<span id="sp_0"></span> je rostlina, která má nedřevnatící nadzemní stonek.',2],
                        ['Z hospodářského škůdce <span id="sp_0"></span> obecného se stal ohrožený druh.',9],
                        ['Jediní aktivně létající savci jsou <span id="sp_0"></span> a kaloni.',11],
                        ['Lidská činnost, při které dochází k plnění <span id="sp_0"></span>, se nazývá pytlování.',12],
                        ['<span id="sp_0"></span> je kovářský oheň s možností vhánění vzduchu.',14],
                        ['Samice koně domácího se nazývá <span id="sp_0"></span>, může se tak označovat i jiná samice z čeledi koňovitých, jako tomu je například u zeber.',3],
                        ['Největší českou sovou je <span id="sp_0"></span> velký.',15], 
                        ['<span id="sp_0"></span> je mléčný výrobek, který obsahuje tuky mléčné, bílkoviny a ostatní složky mléka.',8]
                    ];
                    
         this.vety2 = [
                        ['<span id="sp_0"></span> vozí svůj <span id="sp_1"></span> na zádech.',[6,5]],
                        ['Ve spíži u babičky řádilo několik <span id="sp_0"></span>, byl tam dokonce okousaný <span id="sp_1"></span>.',[7,4]],
                        ['Mimo <span id="sp_0"></span>, obojživelníků a korýšů se <span id="sp_1"></span> živí i drobnými savci.',[21,13]],
                        ['<span id="sp_0"></span> má rozdělené <span id="sp_1"></span>, jedná se tedy o sudokopytníka. ',[1,10]],
                        ['Kovář musel ve <span id="sp_0"></span> rozžhavit podkovu a na kovadlině ji překovat, aby mohl okovat <span id="sp_1"></span>.',[14,3]],
                        ['Stejně jako <span id="sp_0"></span>, jsou sovy, v čele s jejich největším představitelem <span id="sp_1"></span> velkým, nočními lovci.',[11,15]],
                        ['V minulosti byl <span id="sp_0"></span> obecný považován za škůdce, běžně se vyskytoval v zemědělských porostech <span id="sp_1"></span>, kde údajně působil velké škody.',[9,18]],
                        ['Echolokace, tedy způsob orientace dle odrazu ultrazvukových vln, je charakteristickým rysem pro naše noční savce <span id="sp_0"></span>, vyskytuje se i u některých mořských savců, například <span id="sp_1"></span>.',[11,16]],
                        ['Běžný předmět denní potřeby, který slouží k ukládání různých předmětů, zejména sypkých hmot, zemědělských plodin či průmyslových surovin, označujeme jako <span id="sp_0"></span>, bývá vyroben z průmyslové tkaniny či plastu nebo <span id="sp_1"></span>.',[12,20]],
                        ['Otevřené <span id="sp_0"></span>v kovárně nazýváme <span id="sp_1"></span>, v širším smyslu znamená též žár, horko, vedro.',[19,14]],
                        ['Sražením <span id="sp_0"></span> pomocí syřidla nebo kyselinou mléčnou vzniká <span id="sp_1"></span>, který patří mezi nejrozšířenější a neoblíbenější mléčné výrobky.',[17,8]]                         
                    ];
        this.prefix = "image/";
    }
    
    /* Tvorba vět a hromadky obrázků - 3 až pět vět s jedním chybějícím obr*/
    prepare_1(){
        let img, random, span, text;
        let pouzite = [];
        let pocet = Math.round(Math.random()*2)+3;
        let div_dopl = document.createElement("div");         
        div_dopl.classList.add("obr_vyber", "w3-row");
        //let pocet = document.getElementsByClassName("doplnovani_pr1");
        for(let x = 0; x<pocet; x++){
            while(true){
                random = Math.round(Math.random()*11);
                if(pouzite.includes(random) == false){
                    pouzite.push(random);
                    break;    
                }                
            } 
            text = document.createElement("p");  
            text.classList.add("doplnovani_pr1");
            text.innerHTML = this.vety1[random][0];  
            this.rodic.append(text);
            
            span = document.getElementById("sp_0");   
            span.classList.add("span_dopl",this.drop); 
            span.dataset.id = this.vety1[random][1]; 
            span.dataset.pr = 1;
            span.removeAttribute("id");             
            
            img = document.createElement("img");
            img.src = this.prefix+""+this.sl_all[this.vety1[random][1]-1]+".png";
            img.alt = "obr_"+x;
            img.classList.add(this.drag);
            img.dataset.id = this.vety1[random][1]; 
            img.dataset.pr = 1; 
            img.dataset.obt = this.obt;
            div_dopl.append(img);
        }  
        //doplneni obrazky o 3 dalsi
        for(let x = 0; x < 3; x++){
          while(true){
              random = Math.round(Math.random()*10);
              if(pouzite.includes(random) == false){
                  pouzite.push(random);
                  break;    
              }                
          }
          
          img = document.createElement("img");
          img.src = this.prefix+""+this.sl_all[this.vety1[random][1]-1]+".png";
          img.alt = "obr_"+x;
          img.classList.add(this.drag);
          img.dataset.id = this.vety1[random][1];
          img.dataset.pr = 1; 
          img.dataset.obt = this.obt;
          div_dopl.append(img);
        }
        this.rodic.append(div_dopl); 
    }
    
    /* Tvorba vět a hromadky obrázků - 2x1 a 1x2 obr*/
    prepare_2(){
        let img, random, span, text, div_dopl, pouzite_obr;
        let pouzite = [];        
        for(let x = 0; x<3; x++){
            pouzite_obr = [];
            div_dopl = document.createElement("div");
            div_dopl.classList.add("pr2_vyber", "v_pr2_"+x, "w3-row");
            text = document.createElement("p");
            text.classList.add("doplnovani_pr2");
            while(true){
                if(x==2)
                    random = Math.round(Math.random()*10);
                else
                    random = Math.round(Math.random()*11);
                if(pouzite.includes(random) == false){
                    pouzite.push(random);
                    break;    
                }                
            }
            if(x==2){
              text.innerHTML = this.vety2[random][0];  
              this.rodic.append(text);   
              for(let y = 0; y < 2; y++){               
                span = document.getElementById("sp_"+y);   
                span.classList.add("span_dopl",this.drop); 
                span.dataset.id = this.vety2[random][1][y]; 
                span.dataset.pr = x;
                span.removeAttribute("id");              
                img = document.createElement("img");
                img.src = this.prefix+""+this.sl_all[this.vety2[random][1][y]-1]+".png";
                img.alt = "obr_"+x;
                img.classList.add(this.drag, "pr2_p_"+x);
                img.dataset.id = this.vety2[random][1][y];   
                pouzite_obr.push(this.vety2[random][1][y]);
                img.dataset.pr = x;
                img.dataset.obt = this.obt;
                div_dopl.append(img);
              }          
            }else{             
              text.innerHTML = this.vety1[random][0];  
              this.rodic.append(text);              
              span = document.getElementById("sp_0");   
              span.classList.add("span_dopl",this.drop); 
              span.dataset.id = this.vety1[random][1]; 
              span.dataset.pr = x;
              span.removeAttribute("id");  
              img = document.createElement("img");
              img.src = this.prefix+""+this.sl_all[this.vety1[random][1]-1]+".png";
              img.alt = "obr_"+x;
              img.classList.add(this.drag, "pr2_p_"+x);
              img.dataset.id = this.vety1[random][1]; 
              pouzite_obr.push(this.vety1[random][1]);
              img.dataset.pr = x; 
              img.dataset.obt = this.obt;
              div_dopl.append(img);
            }
             
            //doplneni obrazky o 2 dalsi            
            for(let c = 0; c < 2; c++){
              while(true){
                  random = Math.round(Math.random()*10);
                  if(pouzite_obr.includes(this.vety1[random][1]) == false){
                      pouzite_obr.push(this.vety1[random][1]);
                      break;    
                  }                
              }              
              img = document.createElement("img");
              img.src = this.prefix+""+this.sl_all[this.vety1[random][1]-1]+".png";
              img.alt = "obr_"+x;
              img.classList.add(this.drag, "pr2_p_"+x);
              img.dataset.id = this.vety1[random][1];
              img.dataset.pr = x; 
              img.dataset.obt = this.obt;
              div_dopl.append(img);
          }
          this.rodic.append(div_dopl);   
        } 
    }
    
    /* Tvorba vět a hromadky obrázků - 3x2 obr*/      //class="span_dopl '+this.drop+'" data-id="6"
    prepare_3(){
        let img, random, div_dopl, text, span, span_rodic, pouzite_obr;
        let pouzite = [];
        for(let x = 0; x<3; x++){
            pouzite_obr = [];
            div_dopl = document.createElement("div");
            div_dopl.classList.add("pr3_vyber","v_pr3_"+x, "w3-row");
            text = document.createElement("p");
            text.classList.add("doplnovani_pr3");
            while(true){
                random = Math.round(Math.random()*10);
                if(pouzite.includes(random) == false){
                    pouzite.push(random);
                    break;    
                }                
            } 
            text.innerHTML = this.vety2[random][0];
            this.rodic.append(text);           
            
            //tvorba spanu pro vkladani + vlozeni obrazku               
            for(let y = 0; y < 2; y++){               
              span = document.getElementById("sp_"+y);   
              span.classList.add("span_dopl",this.drop); 
              span.dataset.id = this.vety2[random][1][y]; 
              span.dataset.pr = x;
              span.removeAttribute("id");              
              img = document.createElement("img");
              img.src = this.prefix+""+this.sl_all[this.vety2[random][1][y]-1]+".png";
              img.alt = "obr_"+x;
              img.classList.add(this.drag, "pr3_p_"+x);
              img.dataset.id = this.vety2[random][1][y]; 
              img.dataset.pr = x;
              img.dataset.obt = this.obt;
              pouzite_obr.push(this.vety2[random][1][y]);
              div_dopl.append(img);
            } 
            this.rodic.append(div_dopl);
          
          //doplneni obrazky o 3 dalsi
          for(let z = 0; z < 3; z++){
            while(true){
                random = Math.round(Math.random()*10);
                if(pouzite_obr.includes(this.vety1[random][1]) == false){
                    pouzite_obr.push(this.vety1[random][1]);
                    break;    
                }                
            }
            img = document.createElement("img");
            img.src = this.prefix+""+this.sl_all[this.vety1[random][1]-1]+".png";
            img.alt = "obr_"+z;
            img.classList.add(this.drag, "pr3_p_"+x);
            img.dataset.id = this.vety1[random][1]; 
            img.dataset.pr = x;
            img.dataset.obt = this.obt;
            div_dopl.append(img);
          }     
        } 
    }   
    
    /* presun */ 
    setDrag(){
        jQuery("."+this.drag).draggable({ revert: "invalid" });  
        var vlozeno = this.vlozeno;
        var vlozit = this.vlozit;
        var max_vlozit = this.pocetDoplnovani;
        jQuery("."+this.drop).droppable({                                  //anonymni funkce
            drop: function( event, ui) {
            event.preventDefault();
            let presouvane = ui.draggable[0];                              //presouvany
            let kam = event.target                                         //budouci rodic
    
            switch(presouvane.dataset["obt"]){
                case "1": //dochází rovnou k hodnocení
                    kam.appendChild(presouvane);
                    jQuery(kam).droppable("destroy"); 
                    presouvane.removeAttribute("style"); 
                    jQuery(presouvane).draggable("destroy");
                    if(kam.dataset["id"] == presouvane.dataset["id"]){
                        kam.classList.add("dop_ok");
                    }else
                        kam.classList.add("dop_nok");
                break;
                
                case "2": //vkladaji se jen spravne prirazeni
                    if(kam.dataset["pr"] == presouvane.dataset["pr"]){
                      if(kam.dataset["id"] == presouvane.dataset["id"]){
                          pr2vlozeno++;
                          kam.appendChild(presouvane); 
                          jQuery(kam).droppable("destroy");
                          presouvane.removeAttribute("style"); 
                          jQuery(presouvane).draggable("destroy");
                          kam.classList.add("dop_ok");
                          if (pr2vlozeno == 4){
                              if (spravneVklada == true){
                                  var poleTextu = ["Celý příklad na první pokus? Bezva!",
                                      "Ty jo, to teda vážně zírám! Jako mistr!",
                                      "Cože?! Bez jediného navráceného obrázku? Fíha!",
                                      "To jsi mě teda překvapil, že jsi všechno vložil hned správně!",
                                      "Jsem zaskočen, vážně. Tohle se ti opravdu povedlo."];
                                  var index = Math.round(Math.random() * 4);
                                  print_modal("modal", "ok", poleTextu[index]);
                              }else
                                  print_modal("modal", "neutr", "Nevadí, příště to již určitě zvládneš bez vrácených obrázků.");                                   
                          }                              
                      }else
                          spravneVklada = false;    //vklada spatnou moznost z nabizenych 
                          jQuery(presouvane).draggable({revert: true});
                    }else{
                        spravneVklada = false;  //vklada z jine vety 
                        jQuery(presouvane).draggable({revert: true});
                    }                
                break;
                
                case "3": //k hodnoceni dochazi po doplneni vsech prazdnych poli, vrací se jen obrazky z jiné nabídky
                  if(kam.dataset["pr"] == presouvane.dataset["pr"]){
                    let puv_rodic = presouvane.parentNode;
                    //kam.appendChild(presouvane);
                    //jQuery(kam).droppable("destroy");
                    //presouvane.removeAttribute("style");
                    //jQuery(presouvane).draggable("destroy");
                    pokusu++;
                    if(kam.dataset["id"] == presouvane.dataset["id"]){
                        pom_doplneno += 1;
                        //kam.classList.add("dop_ok");
                        //je tam uz nejaky prvek??
                        if(kam.hasChildNodes()){
                            let puv_potomek = kam.firstChild;
                            //zkontroluji spravnost 2. presunu
                            if(puv_potomek.dataset["id"] == puv_rodic.dataset["id"]) pom_doplneno += 1;
                            //puvodniho dam tam, odkad beru
                            puv_rodic.appendChild(puv_potomek);
                            //presunu nove premistovaneho
                            kam.appendChild(presouvane);
                        }else{
                            //ne - vkladam
                            kam.appendChild(presouvane);
                            jQuery(presouvane).draggable();
                        }
                    }else
                        //kam.classList.add("dop_nok");
                        //je tam uz nejaky prvek??
                        if(kam.hasChildNodes()){
                            let puv_potomek = kam.firstChild;
                            //zkontroluji spravnost 2. presunu
                            if(puv_potomek.dataset["id"] == puv_rodic.dataset["id"]) pom_doplneno += 1;
                            else{   //co kdyz to bylo spravne umistene?
                                if(puv_potomek.dataset["id"] == kam.dataset["id"])
                                    pom_doplneno -= 1;
                            }
                            //puvodniho dam tam, odkad beru
                            puv_rodic.appendChild(puv_potomek);
                            //presunu nove premistovaneho
                            kam.appendChild(presouvane);
                            //musim ho zkontrolovat
                        }else{
                            //ne - vkladam
                            kam.appendChild(presouvane);
                            jQuery(presouvane).draggable();
                        }
                        presouvane.style.left = "0px";
                        presouvane.style.top = "0px";
                     //presouvane.removeAttribute("style");      //odebiram css styly, aby to sedelo na miste
                  }else{
                    //vklada se obrazek z jine nabidky -> vracim ho zpet
                    jQuery(presouvane).draggable({revert: true});
                  }
                  //console.log(pom_doplneno);
                  if(pom_doplneno == max_vlozit){
                    //az budu mit spravne vse, tak tady to obarvim
                    let mista_doplneni = document.getElementsByClassName('drop_3');
                    jQuery(".drop_3").droppable("destroy");
                    jQuery(".drag_3").draggable("destroy");
                    for(let x = 0; x< mista_doplneni.length;x++){
                        mista_doplneni[x].classList.add("dop_ok");
                    }
                    if(pokusu == max_vlozit){
                        print_modal("modal", "ok");    
                    }else
                        print_modal("modal", "neutr", "Nevadí! Na první pokus to nebylo, ale příště to bude ok!");
                  }
               break;            
            }                                                
            } 
        });      
    }
         
}

var priklad_1 = new veta('tab_pr_1',1);
priklad_1.prepare_1();
priklad_1.setDrag();
prohazej('drag_1','obr_vyber');    

var priklad_2 = new veta('tab_pr_2',2);
priklad_2.prepare_2();
priklad_2.setDrag();
var pr2vlozeno = 0;
var spravneVklada = true;
prohazej("pr2_p_0","v_pr2_0");         
prohazej("pr2_p_1","v_pr2_1");     
prohazej("pr2_p_2","v_pr2_2");  

var priklad_3 = new veta('tab_pr_3',3);       
priklad_3.prepare_3();
var pom_doplneno = 0;
var pokusu = 0;
priklad_3.setDrag();   
prohazej("pr3_p_0","v_pr3_0");         
prohazej("pr3_p_1","v_pr3_1");     
prohazej("pr3_p_2","v_pr3_2");  


